Drupal.behaviors.cssWatch = {
  attach: function(){
    (function ($){
        CSSWatch = {
          paths: Drupal.settings.cssWatch.paths,
          poll: Drupal.settings.cssWatch.pollInterval,
          init: function(){
            CSSWatch.widget();
            if($.cookie('cssWatchCookie') == null) {
              CSSWatch.values('on', 'off');
              CSSWatch.start();
            } else {
              if($.cookie('cssWatchCookie') == 'on'){
                CSSWatch.start();
              }
            }
            CSSWatch.control();
          },
          control: function(){
            $('#css-watch').click(function() {
              $(this).hasClass('on') ? CSSWatch.stop() : CSSWatch.start();
            });
          },
          start: function() {
            CSSWatch.values('on', 'off');
            CSSWatch.startPolling(CSSWatch.paths);
          },
          stop: function() {
            CSSWatch.values('off', 'on');
            clearInterval(CSSWatch.loopId);
          },
          startPolling: function(paths){
            CSSWatch.loopId = setInterval(function(){
              paths.forEach(function(item, index){
                fileCheck(paths[index]);
               });
            }, this.poll);
            function fileCheck(path){
              $.ajax({
                url: path,
                ifModified: true,
                success: function(data, textStatus, jqXHR) {
                  if(textStatus != 'notmodified') {
                    var queryString = '?_'  + new Date().getTime();
                    $('link[href^="' + path + '"]').attr("href", path.replace(/\?.*|$/, queryString));
                  }
                },
              });
            }
          },
          values: function(first, second){
            $('#css-watch').addClass(first).removeClass(second);
            $.cookie('cssWatchCookie', first, {expires: 7, path: '/'});
          },
          widget: function(){
            $('body').append('<div id="css-watch" class="' + $.cookie("cssWatchCookie") + '"><span></span></div>');
          }
        } // end of object
        CSSWatch.init();
     })(jQuery)
  }
};
